//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "first.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall JonsClass::JonsClass()
{
FMyString = "";
FMyDateTime = Now();
}
//---------------------------------------------------------------------------
void __fastcall JonsClass::LoadFromStream(TStream *sStream)
{
char *Buffy = NULL;
int TempSize;

//read datetime off stream.
sStream->Read(&FMyDateTime, sizeof(TDateTime));
//read string off stream
sStream->Read(&TempSize, sizeof(TempSize));
if(TempSize > 0)
    {
    try
        {
        Buffy = new char[TempSize + 1];
        sStream->Read(Buffy, TempSize);
        Buffy[TempSize] = '\0';  //add null terminator
        FMyString = Buffy;
        }
    __finally
        {
        if(Buffy)
            delete [] Buffy;
        }
    }
else
    FMyString = "";
}
//---------------------------------------------------------------------------
void __fastcall JonsClass::SaveToStream(TStream *sStream)
{//write data
int TempSize;
//write DateTime
sStream->Write(&FMyDateTime, sizeof(TDateTime));
//write String
TempSize = FMyString.Length();
sStream->Write(&TempSize, sizeof(TempSize));
sStream->Write(FMyString.c_str(), TempSize);
}
//---------------------------------------------------------------------------
void __fastcall JonsClass::SaveToFile(String FFileName)
{
TFileStream *MyFile = NULL;

try
    {
    MyFile = new TFileStream(FFileName, fmCreate|fmShareDenyWrite);
    SaveToStream(MyFile);
    }
__finally
    {
    if(MyFile)
        delete MyFile;
    }
}
//---------------------------------------------------------------------------
void __fastcall JonsClass::LoadFromFile(String FFileName)
{
TFileStream *MyFile = NULL;

try
    {
    MyFile = new TFileStream(FFileName, fmOpenRead|fmShareDenyWrite);
    LoadFromStream(MyFile);
    }
__finally
    {
    if(MyFile)
        delete MyFile;
    }
}
//---------------------------------------------------------------------------
void __fastcall jClassList::SaveToStream(TStream *sStream)
{
int Counter = Count;
JonsClass *sparejClass;

sStream->Size = 0;  //we're overwriting
for(int x = 0; x < Counter; x++)
    {
    sparejClass = dynamic_cast <JonsClass *> (Items[x]);
    sparejClass->SaveToStream(sStream);
    }
}
//---------------------------------------------------------------------------
void __fastcall jClassList::LoadFromStream(TStream *sStream)
{
JonsClass *sparejClass;

sStream->Seek(0, soFromBeginning);

while(sStream->Position < sStream->Size)
    {
    sparejClass = new JonsClass;
    sparejClass->LoadFromStream(sStream);
    Add(sparejClass);
    }
}
//---------------------------------------------------------------------------
void __fastcall jClassList::SaveToFile(String FFileName)
{
TFileStream *MyFile = NULL;

try
    {
    MyFile = new TFileStream(FFileName, fmCreate|fmShareDenyWrite);
    SaveToStream(MyFile);
    }
__finally
    {
    if(MyFile)
        delete MyFile;
    }
}
//---------------------------------------------------------------------------
void __fastcall jClassList::LoadFromFile(String FFileName)
{
TFileStream *MyFile = NULL;

try
    {
    MyFile = new TFileStream(FFileName, fmOpenRead|fmShareDenyWrite);
    LoadFromStream(MyFile);
    }
__finally
    {
    if(MyFile)
        delete MyFile;
    }
}
//---------------------------------------------------------------------------


